/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.45 Revision 1.129
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.45 2009/10/02 15:04:23 ayoy Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.129 2012/05/20 17:12:34 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
11# @DESCRIPTION: 9# @DESCRIPTION:
12# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
13 11
12case ${EAPI} in
13 2|3|4) : ;;
14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
14inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit base eutils flag-o-matic multilib toolchain-funcs versionator
15 18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
28
29MY_PV=${PV/_/-}
30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH="${PV%.9999}"
37 ;;
38 release)
39 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
40 ;;
41esac
42
16IUSE="${IUSE} debug pch" 43IUSE="aqua debug pch"
44if [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]]; then
45 IUSE+=" +exceptions"
46fi
47if version_is_at_least 4.8; then
48 IUSE+=" c++0x qpa"
49fi
50
51DEPEND="virtual/pkgconfig"
52if [[ ${QT4_BUILD_TYPE} == live ]]; then
53 DEPEND+=" dev-lang/perl"
54fi
55
17RDEPEND=" 56RDEPEND="
18 !<x11-libs/qt-assistant-${PV} 57 !<x11-libs/qt-assistant-${PV}
19 !>x11-libs/qt-assistant-${PV}-r9999 58 !>x11-libs/qt-assistant-${PV}-r9999
59 !<x11-libs/qt-bearer-${PV}
60 !>x11-libs/qt-bearer-${PV}-r9999
20 !<x11-libs/qt-core-${PV} 61 !<x11-libs/qt-core-${PV}
21 !>x11-libs/qt-core-${PV}-r9999 62 !>x11-libs/qt-core-${PV}-r9999
22 !<x11-libs/qt-dbus-${PV} 63 !<x11-libs/qt-dbus-${PV}
23 !>x11-libs/qt-dbus-${PV}-r9999 64 !>x11-libs/qt-dbus-${PV}-r9999
65 !<x11-libs/qt-declarative-${PV}
66 !>x11-libs/qt-declarative-${PV}-r9999
24 !<x11-libs/qt-demo-${PV} 67 !<x11-libs/qt-demo-${PV}
25 !>x11-libs/qt-demo-${PV}-r9999 68 !>x11-libs/qt-demo-${PV}-r9999
26 !<x11-libs/qt-gui-${PV} 69 !<x11-libs/qt-gui-${PV}
27 !>x11-libs/qt-gui-${PV}-r9999 70 !>x11-libs/qt-gui-${PV}-r9999
71 !<x11-libs/qt-multimedia-${PV}
72 !>x11-libs/qt-multimedia-${PV}-r9999
28 !<x11-libs/qt-opengl-${PV} 73 !<x11-libs/qt-opengl-${PV}
29 !>x11-libs/qt-opengl-${PV}-r9999 74 !>x11-libs/qt-opengl-${PV}-r9999
75 !<x11-libs/qt-openvg-${PV}
76 !>x11-libs/qt-openvg-${PV}-r9999
30 !<x11-libs/qt-phonon-${PV} 77 !<x11-libs/qt-phonon-${PV}
31 !>x11-libs/qt-phonon-${PV}-r9999 78 !>x11-libs/qt-phonon-${PV}-r9999
32 !<x11-libs/qt-qt3support-${PV} 79 !<x11-libs/qt-qt3support-${PV}
33 !>x11-libs/qt-qt3support-${PV}-r9999 80 !>x11-libs/qt-qt3support-${PV}-r9999
34 !<x11-libs/qt-script-${PV} 81 !<x11-libs/qt-script-${PV}
42 !<x11-libs/qt-webkit-${PV} 89 !<x11-libs/qt-webkit-${PV}
43 !>x11-libs/qt-webkit-${PV}-r9999 90 !>x11-libs/qt-webkit-${PV}-r9999
44 !<x11-libs/qt-xmlpatterns-${PV} 91 !<x11-libs/qt-xmlpatterns-${PV}
45 !>x11-libs/qt-xmlpatterns-${PV}-r9999 92 !>x11-libs/qt-xmlpatterns-${PV}-r9999
46" 93"
47case "${PV}" in 94
48 4.?.?_rc*)
49 SRCTYPE="${SRCTYPE:-opensource-src}"
50 MY_PV="${PV/_rc/-rc}"
51 ;;
52 *)
53 SRCTYPE="${SRCTYPE:-opensource-src}"
54 MY_PV="${PV}"
55 ;;
56esac
57MY_P=qt-x11-${SRCTYPE}-${MY_PV}
58S=${WORKDIR}/${MY_P} 95S=${WORKDIR}/${MY_P}
59 96
60HOMEPAGE="http://qt.nokia.com/"
61SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.bz2"
62if version_is_at_least 4.5.3 ${PV} ; then
63 SRC_URI="${SRC_URI/bz2/gz}"
64fi
65
66case "${PV}" in
67 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
68 *) ;;
69esac
70
71if version_is_at_least 4.5 ${PV} ; then
72 LICENSE="|| ( LGPL-2.1 GPL-3 )"
73fi
74
75# @FUNCTION: qt4-build_pkg_setup 97# @FUNCTION: qt4-build_pkg_setup
76# @DESCRIPTION: 98# @DESCRIPTION:
77# Sets up installation directories, PLATFORM, PATH, and LD_LIBRARY_PATH 99# Sets up PATH and LD_LIBRARY_PATH.
78qt4-build_pkg_setup() { 100qt4-build_pkg_setup() {
79 # EAPI=2 ebuilds set use-deps, others need this: 101 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
80 if [[ $EAPI != 2 ]]; then 102
81 # Make sure debug setting corresponds with qt-core (bug 258512) 103 # Protect users by not allowing downgrades between releases
82 if [[ $PN != "qt-core" ]]; then 104 # Downgrading revisions within the same release should be allowed
83 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 105 if has_version '>'${CATEGORY}/${P}-r9999; then
84 ~x11-libs/qt-core-${PV} debug" 106 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
107 eerror
108 eerror "Sanity check to keep you from breaking your system:"
109 eerror " Downgrading Qt is completely unsupported and will break your system!"
110 eerror
111 die "aborting to save your system"
112 else
113 ewarn "Downgrading Qt is completely unsupported and will break your system!"
85 fi 114 fi
115 fi
86 116
87 # Check USE requirements 117 if [[ ${PN} == qt-webkit ]]; then
88 qt4-build_check_use 118 eshopts_push -s extglob
119 if is-flagq '-g?(gdb)?([1-9])'; then
120 echo
121 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
122 ewarn "You may experience really long compilation times and/or increased memory usage."
123 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
124 ewarn "For more info check out bug #307861"
125 echo
89 fi 126 fi
127 eshopts_pop
128 fi
90 129
91 PATH="${S}/bin:${PATH}" 130 PATH="${S}/bin${PATH:+:}${PATH}"
131 if [[ ${CHOST} != *-darwin* ]]; then
92 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 132 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
133 else
134 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
135 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
136 # platform detection. Note: needs to come before any directories to
137 # avoid extract failure.
138 [[ ${CHOST} == *-apple-darwin* ]] && \
139 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
140 ${QT4_EXTRACT_DIRECTORIES}"
141 fi
93 142
94 if ! version_is_at_least 4.1 $(gcc-version) ; then 143 if ! version_is_at_least 4.1 $(gcc-version); then
95 ewarn "Using a GCC version lower than 4.1 is not supported!" 144 ewarn "Using a GCC version lower than 4.1 is not supported."
96 echo
97 ebeep 3
98 fi 145 fi
99} 146}
100 147
101# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 148# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
102# @DESCRIPTION: 149# @DESCRIPTION:
103# Arguments for build_target_directories. Takes the directories, in which the 150# Arguments for build_target_directories. Takes the directories in which the
104# code should be compiled. This is a space-separated list 151# code should be compiled. This is a space-separated list.
105 152
106# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 153# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
107# @DESCRIPTION: 154# @DESCRIPTION:
108# Space separated list including the directories that will be extracted from Qt 155# Space-separated list including the directories that will be extracted from
109# tarball 156# Qt tarball.
110 157
111# @FUNCTION: qt4-build_src_unpack 158# @FUNCTION: qt4-build_src_unpack
112# @DESCRIPTION: 159# @DESCRIPTION:
113# Unpacks the sources 160# Unpacks the sources.
114qt4-build_src_unpack() { 161qt4-build_src_unpack() {
115 setqtenv 162 setqtenv
116 local target targets licenses tar_pkg tar_args 163
117 if version_is_at_least 4.5 ${PV} ; then 164 case ${QT4_BUILD_TYPE} in
118 licenses="LICENSE.GPL3 LICENSE.LGPL" 165 live)
119 else 166 git-2_src_unpack
120 licenses="LICENSE.GPL2 LICENSE.GPL3" 167 ;;
121 fi 168 release)
122 for target in configure ${licenses} projects.pro \ 169 local tarball="${MY_P}.tar.gz" target= targets=
170 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
123 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 171 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
124 ${QT4_EXTRACT_DIRECTORIES}; do 172 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
173 do
125 targets="${targets} ${MY_P}/${target}" 174 targets+="${MY_P}/${target} "
126 done 175 done
127 176
128 tar_pkg=${MY_P}.tar.bz2 177 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
129 tar_args="xjpf" 178 tar -xzf "${DISTDIR}/${tarball}" ${targets}
130 if version_is_at_least 4.5.3 ${PV} ; then 179 eend $? || die "failed to unpack"
131 tar_pkg=${tar_pkg/bz2/gz}
132 tar_args="xzpf"
133 fi
134
135 echo tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
136 tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
137
138 case "${PV}" in
139 4.4.?)
140 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
141 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
142 ;; 180 ;;
143 esac 181 esac
144
145 # Be backwards compatible for now
146 if [[ $EAPI != 2 ]]; then
147 qt4-build_src_prepare
148 fi
149} 182}
150 183
151# @ECLASS-VARIABLE: PATCHES 184# @ECLASS-VARIABLE: PATCHES
185# @DEFAULT_UNSET
152# @DESCRIPTION: 186# @DESCRIPTION:
153# In case you have patches to apply, specify them in PATCHES variable. Make sure 187# PATCHES array variable containing all various patches to be applied.
154# to specify the full path. This variable is necessary for src_prepare phase. 188# This variable is expected to be defined in global scope of ebuild.
155# example: 189# Make sure to specify the full path. This variable is utilised in
156# PATCHES="${FILESDIR}"/mypatch.patch 190# src_unpack/src_prepare phase, based on EAPI.
157# ${FILESDIR}"/mypatch2.patch"
158# 191#
192# @CODE
193# PATCHES=( "${FILESDIR}/mypatch.patch"
194# "${FILESDIR}/patches_folder/" )
195# @CODE
159 196
160# @FUNCTION: qt4-build_src_prepare 197# @FUNCTION: qt4-build_src_prepare
161# @DESCRIPTION: 198# @DESCRIPTION:
162# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 199# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
163# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 200# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
164qt4-build_src_prepare() { 201qt4-build_src_prepare() {
165 setqtenv 202 setqtenv
166 cd "${S}" 203
204 if [[ ${QT4_BUILD_TYPE} == live ]]; then
205 QTDIR="." ./bin/syncqt || die "syncqt failed"
206 fi
207
208 if version_is_at_least 4.7; then
209 # fix libX11 dependency on non X packages
210 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
211 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
212
213 qt_assistant_cleanup
214 fi
215
216 if use aqua; then
217 # provide a proper macx-g++-64
218 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
219
220 sed -e '/^CONFIG/s:app_bundle::' \
221 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
222 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
223 fi
167 224
168 if [[ ${PN} != qt-core ]]; then 225 if [[ ${PN} != qt-core ]]; then
169 skip_qmake_build_patch 226 skip_qmake_build
170 skip_project_generation_patch 227 skip_project_generation
171 symlink_binaries_to_buildtree 228 symlink_binaries_to_buildtree
172 fi 229 fi
173 230
231 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
232 # qmake bus errors with -O2 or -O3 but -O1 works
233 # Bug 373061
234 replace-flags -O[23] -O1
235 fi
236
174 # Bug 178652 237 # Bug 178652
175 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 238 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
176 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 239 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
177 append-flags -fno-gcse 240 append-flags -fno-gcse
178 fi 241 fi
179 242
243 if use_if_iuse c++0x; then
244 echo
245 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
246 ewarn "this is an official standard, some of the reverse dependencies"
247 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
248 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
249 ewarn "disabled."
250 echo
251 append-flags -std=c++0x
252 fi
253
180 # Unsupported old gcc versions - hardened needs this :( 254 # Unsupported old gcc versions - hardened needs this :(
181 if [[ $(gcc-major-version) -lt "4" ]] ; then 255 if [[ $(gcc-major-version) -lt 4 ]]; then
182 ewarn "Appending -fno-stack-protector to CXXFLAGS" 256 ewarn "Appending -fno-stack-protector to CXXFLAGS"
183 append-cxxflags -fno-stack-protector 257 append-cxxflags -fno-stack-protector
184 # Bug 253127 258 # Bug 253127
185 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 259 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
186 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 260 -i mkspecs/common/g++.conf || die
261 fi
262
263 # Bug 261632
264 if use ppc64; then
265 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
266 append-flags -mminimal-toc
267 fi
268
269 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
270 sed -e "/^SYSTEM_VARIABLES=/i \
271 CC='$(tc-getCC)'\n\
272 CXX='$(tc-getCXX)'\n\
273 CFLAGS='${CFLAGS}'\n\
274 CXXFLAGS='${CXXFLAGS}'\n\
275 LDFLAGS='${LDFLAGS}'\n" \
276 -i configure \
277 || die "sed SYSTEM_VARIABLES failed"
278
279 # Respect CC, CXX, LINK and *FLAGS in config.tests
280 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
281 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
282 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
283 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
284 || die "sed config.tests failed"
285
286 if ! version_is_at_least 4.8; then
287 # Strip predefined CFLAGS from mkspecs (bugs 312689 and 352778)
288 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
187 fi 289 fi
188 290
189 # Bug 172219 291 # Bug 172219
292 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
293
294 if [[ ${CHOST} == *-darwin* ]]; then
295 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
296 # crippled (by design) :/
297 local mac_gpp_conf=
298 if [[ -f mkspecs/common/mac-g++.conf ]]; then
299 # qt < 4.8 has mac-g++.conf
300 mac_gpp_conf="mkspecs/common/mac-g++.conf"
301 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
302 # qt >= 4.8 has g++-macx.conf
303 mac_gpp_conf="mkspecs/common/g++-macx.conf"
304 else
305 die "no known conf file for mac found"
306 fi
307 sed \
190 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 308 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
191 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 309 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
192 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 310 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
193 -e "s:X11R6/::" \ 311 -e "s:-arch\s\w*::g" \
194 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 312 -i ${mac_gpp_conf} \
313 || die "sed ${mac_gpp_conf} failed"
195 314
196 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 315 # Fix configure's -arch settings that appear in qmake/Makefile and also
197 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 316 # fix arch handling (automagically duplicates our -arch arg and breaks
198 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 317 # pch). Additionally disable Xarch support.
199 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 318 local mac_gcc_confs="${mac_gpp_conf}"
319 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
320 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
321 fi
322 sed \
323 -e "s:-arch i386::" \
324 -e "s:-arch ppc::" \
325 -e "s:-arch x86_64::" \
326 -e "s:-arch ppc64::" \
327 -e "s:-arch \$i::" \
328 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
329 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
330 -e "s:-Xarch_x86_64::g" \
331 -e "s:-Xarch_ppc64::g" \
332 -i configure ${mac_gcc_confs} \
333 || die "sed -arch/-Xarch failed"
334
335 # On Snow Leopard don't fall back to 10.5 deployment target.
336 if [[ ${CHOST} == *-apple-darwin10 ]]; then
337 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
338 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
339 -i configure ${mac_gpp_conf} \
340 || die "sed deployment target failed"
341 fi
342 fi
343
344 # this one is needed for all systems with a separate -liconv, apart from
345 # Darwin, for which the sources already cater for -liconv
346 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
347 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
348 -i config.tests/unix/iconv/iconv.pro \
349 || die "sed iconv.pro failed"
350 fi
351
352 # we need some patches for Solaris
353 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
354 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
355 # use GCC over SunStudio
356 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
357 # do not flirt with non-Prefix stuff, we're quite possessive
358 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
359 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
200 360
201 base_src_prepare 361 base_src_prepare
202} 362}
203 363
204# @FUNCTION: qt4-build_src_configure 364# @FUNCTION: qt4-build_src_configure
205# @DESCRIPTION: 365# @DESCRIPTION:
206# Default configure phase 366# Default configure phase
207qt4-build_src_configure() { 367qt4-build_src_configure() {
208 setqtenv 368 setqtenv
209 myconf="$(standard_configure_options) ${myconf}"
210 369
211 echo ./configure ${myconf}
212 ./configure ${myconf} || die "./configure failed"
213 myconf=""
214}
215
216# @FUNCTION: qt4-build_src_compile
217# @DESCRIPTION: Actual compile phase
218qt4-build_src_compile() {
219 setqtenv
220 # Be backwards compatible for now
221 if [[ $EAPI != 2 ]]; then
222 qt4-build_src_configure
223 fi
224
225 build_directories "${QT4_TARGET_DIRECTORIES}"
226}
227
228# @FUNCTION: qt4-build_src_install
229# @DESCRIPTION:
230# Perform the actual installation including some library fixes.
231qt4-build_src_install() {
232 setqtenv
233 install_directories "${QT4_TARGET_DIRECTORIES}"
234 install_qconfigs
235 fix_library_files
236}
237
238# @FUNCTION: setqtenv
239setqtenv() {
240 # Set up installation directories
241 QTBASEDIR=/usr/$(get_libdir)/qt4
242 QTPREFIXDIR=/usr
243 QTBINDIR=/usr/bin
244 QTLIBDIR=/usr/$(get_libdir)/qt4
245 QMAKE_LIBDIR_QT=${QTLIBDIR}
246 QTPCDIR=/usr/$(get_libdir)/pkgconfig
247 QTDATADIR=/usr/share/qt4
248 QTDOCDIR=/usr/share/doc/qt-${PV}
249 QTHEADERDIR=/usr/include/qt4
250 QTPLUGINDIR=${QTLIBDIR}/plugins
251 QTSYSCONFDIR=/etc/qt4
252 QTTRANSDIR=${QTDATADIR}/translations
253 QTEXAMPLESDIR=${QTDATADIR}/examples
254 QTDEMOSDIR=${QTDATADIR}/demos
255 QT_INSTALL_PREFIX=/usr/$(get_libdir)/qt4
256 PLATFORM=$(qt_mkspecs_dir)
257
258 unset QMAKESPEC
259}
260
261# @FUNCTION: standard_configure_options
262# @DESCRIPTION:
263# Sets up some standard configure options, like libdir (if necessary), whether
264# debug info is wanted or not.
265standard_configure_options() {
266 local myconf="" 370 local conf="
267 371 -prefix ${QTPREFIXDIR}
268 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 372 -bindir ${QTBINDIR}
269 373 -libdir ${QTLIBDIR}
270 # Disable visibility explicitly if gcc version isn't 4 374 -docdir ${QTDOCDIR}
271 if [[ "$(gcc-major-version)" -lt "4" ]]; then 375 -headerdir ${QTHEADERDIR}
272 myconf="${myconf} -no-reduce-exports" 376 -plugindir ${QTPLUGINDIR}
273 fi 377 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
274 378 -datadir ${QTDATADIR}
275 # precompiled headers doesn't work on hardened, where the flag is masked. 379 -translationdir ${QTTRANSDIR}
276 if use pch; then 380 -sysconfdir ${QTSYSCONFDIR}
277 myconf="${myconf} -pch" 381 -examplesdir ${QTEXAMPLESDIR}
278 else 382 -demosdir ${QTDEMOSDIR}
279 myconf="${myconf} -no-pch" 383 -opensource -confirm-license
280 fi 384 -shared -fast -largefile -stl -verbose
281 385 -nomake examples -nomake demos"
282 if use debug; then
283 myconf="${myconf} -debug -no-separate-debug-info"
284 else
285 myconf="${myconf} -release -no-separate-debug-info"
286 fi
287 386
288 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 387 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
289 # $(tc-arch). Therefore we convert it to supported values. 388 # $(tc-arch). Therefore we convert it to supported values.
290 case "$(tc-arch)" in 389 case "$(tc-arch)" in
291 amd64) myconf="${myconf} -arch x86_64" ;; 390 amd64|x64-*) conf+=" -arch x86_64" ;;
391 ppc-macos) conf+=" -arch ppc" ;;
292 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 392 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
393 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
394 x86-macos) conf+=" -arch x86" ;;
293 x86|x86-*) myconf="${myconf} -arch i386" ;; 395 x86|x86-*) conf+=" -arch i386" ;;
294 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 396 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
295 hppa|sh) myconf="${myconf} -arch generic" ;; 397 hppa|sh) conf+=" -arch generic" ;;
296 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 398 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
297 esac 399 esac
298 400
299 myconf="${myconf} -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license -no-rpath 401 conf+=" -platform $(qt_mkspecs_dir)"
300 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
301 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
302 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
303 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
304 -demosdir ${QTDEMOSDIR} -silent -fast
305 $([[ ${PN} == qt-xmlpatterns ]] || echo -no-exceptions)
306 -reduce-relocations -nomake examples -nomake demos"
307 402
308 # Make eclass 4.5.{1,2} ready 403 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
309 case "${MY_PV}" in
310 4.5.1 | 4.5.2)
311 myconf="${myconf} -opensource"
312 ;;
313 esac
314 404
405 # debug/release
406 if use debug; then
407 conf+=" -debug"
408 else
409 conf+=" -release"
410 fi
411 conf+=" -no-separate-debug-info"
412
413 # exceptions USE flag
414 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
415
416 # disable RPATH on Qt >= 4.8 (bug 380415)
417 version_is_at_least 4.8 && conf+=" -no-rpath"
418
419 # precompiled headers don't work on hardened, where the flag is masked
420 conf+=" $(qt_use pch)"
421
422 # -reduce-relocations
423 # This flag seems to introduce major breakage to applications,
424 # mostly to be seen as a core dump with the message "QPixmap: Must
425 # construct a QApplication before a QPaintDevice" on Solaris.
426 # -- Daniel Vergien
427 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
428
429 # this one is needed for all systems with a separate -liconv, apart from
430 # Darwin, for which the sources already cater for -liconv
431 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
432 conf+=" -liconv"
433 fi
434
435 if use_if_iuse glib; then
436 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
437 # avoid the -pthread argument
438 conf+=" ${glibflags//-pthread}"
439 unset glibflags
440 fi
441
442 if use_if_iuse qpa; then
443 echo
444 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
445 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
446 ewarn "disable it before reporting any bugs related to this useflag."
447 echo
448 conf+=" -qpa"
449 fi
450
451 if use aqua; then
452 # On (snow) leopard use the new (frameworked) cocoa code.
453 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
454 conf+=" -cocoa -framework"
455 # We need the source's headers, not the installed ones.
456 conf+=" -I${S}/include"
457 # Add hint for the framework location.
458 conf+=" -F${QTLIBDIR}"
459
460 # We are crazy and build cocoa + qt3support :-)
461 if use qt3support; then
462 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
463 -i configure || die
464 fi
465 else
466 conf+=" -no-framework"
467 fi
468 else
469 # freetype2 include dir is non-standard, thus pass it to configure
470 conf+=" $(pkg-config --cflags-only-I freetype2)"
471 fi
472
315 echo "${myconf}" 473 conf+=" ${myconf}"
474 myconf=
475
476 echo ./configure ${conf}
477 ./configure ${conf} || die "./configure failed"
478
479 prepare_directories ${QT4_TARGET_DIRECTORIES}
316} 480}
481
482# @FUNCTION: qt4-build_src_compile
483# @DESCRIPTION:
484# Actual compile phase
485qt4-build_src_compile() {
486 setqtenv
487
488 build_directories ${QT4_TARGET_DIRECTORIES}
489}
490
491# @FUNCTION: qt4-build_src_test
492# @DESCRIPTION:
493# Runs tests only in target directories.
494qt4-build_src_test() {
495 # QtMultimedia does not have any test suite (bug #332299)
496 [[ ${PN} == qt-multimedia ]] && return
497
498 for dir in ${QT4_TARGET_DIRECTORIES}; do
499 emake -j1 check -C ${dir}
500 done
501}
502
503# @FUNCTION: fix_includes
504# @DESCRIPTION:
505# For MacOS X we need to add some symlinks when frameworks are
506# being used, to avoid complications with some more or less stupid packages.
507fix_includes() {
508 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
509 local frw dest f h rdir
510 # Some packages tend to include <Qt/...>
511 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
512
513 # Fake normal headers when frameworks are installed... eases life later
514 # on, make sure we use relative links though, as some ebuilds assume
515 # these dirs exist in src_install to add additional files
516 f=${QTHEADERDIR}
517 h=${QTLIBDIR}
518 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
519 f=${f#*/}
520 h=${h#*/}
521 done
522 rdir=${h}
523 f="../"
524 while [[ ${h} == */* ]] ; do
525 f="${f}../"
526 h=${h#*/}
527 done
528 rdir="${f}${rdir}"
529
530 for frw in "${D}${QTLIBDIR}"/*.framework; do
531 [[ -e "${frw}"/Headers ]] || continue
532 f=$(basename ${frw})
533 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
534 dosym "${rdir}"/${f}/Headers "${dest}"
535
536 # Link normal headers as well.
537 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
538 h=$(basename ${hdr})
539 dosym "../${rdir}"/${f}/Headers/${h} \
540 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
541 done
542 done
543 fi
544}
545
546# @FUNCTION: qt4-build_src_install
547# @DESCRIPTION:
548# Perform the actual installation including some library fixes.
549qt4-build_src_install() {
550 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
551 setqtenv
552
553 install_directories ${QT4_TARGET_DIRECTORIES}
554 install_qconfigs
555 fix_library_files
556 fix_includes
557
558 # remove .la files since we are building only shared Qt libraries
559 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
560}
561
562# @FUNCTION: setqtenv
563# @INTERNAL
564setqtenv() {
565 # Set up installation directories
566 QTPREFIXDIR=${EPREFIX}/usr
567 QTBINDIR=${EPREFIX}/usr/bin
568 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
569 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
570 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
571 QTHEADERDIR=${EPREFIX}/usr/include/qt4
572 QTPLUGINDIR=${QTLIBDIR}/plugins
573 QTIMPORTDIR=${QTLIBDIR}/imports
574 QTDATADIR=${EPREFIX}/usr/share/qt4
575 QTTRANSDIR=${QTDATADIR}/translations
576 QTSYSCONFDIR=${EPREFIX}/etc/qt4
577 QTEXAMPLESDIR=${QTDATADIR}/examples
578 QTDEMOSDIR=${QTDATADIR}/demos
579 QMAKE_LIBDIR_QT=${QTLIBDIR}
580 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
581
582 PLATFORM=$(qt_mkspecs_dir)
583 unset QMAKESPEC
584
585 export XDG_CONFIG_HOME="${T}"
586}
587
588# @FUNCTION: prepare_directories
589# @USAGE: < directories >
590# @INTERNAL
591# @DESCRIPTION:
592# Generates Makefiles for the given list of directories.
593prepare_directories() {
594 for x in "$@"; do
595 pushd "${S}"/${x} >/dev/null || die
596 einfo "Running qmake in: ${x}"
597 # avoid running over the maximum argument number, bug #299810
598 {
599 echo "${S}"/mkspecs/common/*.conf
600 find "${S}" -name '*.pr[io]'
601 } | xargs sed -i \
602 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
603 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
604 || die
605 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
606 popd >/dev/null || die
607 done
608}
609
317 610
318# @FUNCTION: build_directories 611# @FUNCTION: build_directories
319# @USAGE: < directories > 612# @USAGE: < directories >
613# @INTERNAL
320# @DESCRIPTION: 614# @DESCRIPTION:
321# Compiles the code in $QT4_TARGET_DIRECTORIES 615# Compiles the code in the given list of directories.
322build_directories() { 616build_directories() {
323 local dirs="$@"
324 for x in ${dirs}; do 617 for x in "$@"; do
325 cd "${S}"/${x} 618 pushd "${S}"/${x} >/dev/null || die
326 sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:/usr/$(get_libdir)/qt4:g" $(find "${S}" -name '*.pr[io]') "${S}"/mkspecs/common/linux.conf || die 619 emake CC="$(tc-getCC)" \
327 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 620 CXX="$(tc-getCXX)" \
328 emake || die "emake failed" 621 LINK="$(tc-getCXX)" || die "emake failed"
622 popd >/dev/null || die
329 done 623 done
330} 624}
331 625
332# @FUNCTION: install_directories 626# @FUNCTION: install_directories
333# @USAGE: < directories > 627# @USAGE: < directories >
628# @INTERNAL
334# @DESCRIPTION: 629# @DESCRIPTION:
335# run emake install in the given directories, which are separated by spaces 630# Runs emake install in the given directories, which are separated by spaces.
336install_directories() { 631install_directories() {
337 local dirs="$@"
338 for x in ${dirs}; do 632 for x in "$@"; do
339 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 633 pushd "${S}"/${x} >/dev/null || die
340 emake INSTALL_ROOT="${D}" install || die "emake install failed" 634 emake INSTALL_ROOT="${D}" install || die "emake install failed"
341 popd >/dev/null || die "Can't popd from ${S}/${x}" 635 popd >/dev/null || die
342 done 636 done
343} 637}
344 638
345# @ECLASS-VARIABLE: QCONFIG_ADD 639# @ECLASS-VARIABLE: QCONFIG_ADD
346# @DESCRIPTION: 640# @DESCRIPTION:
347# List options that need to be added to QT_CONFIG in qconfig.pri 641# List options that need to be added to QT_CONFIG in qconfig.pri
348QCONFIG_ADD="${QCONFIG_ADD:-}" 642: ${QCONFIG_ADD:=}
349 643
350# @ECLASS-VARIABLE: QCONFIG_REMOVE 644# @ECLASS-VARIABLE: QCONFIG_REMOVE
351# @DESCRIPTION: 645# @DESCRIPTION:
352# List options that need to be removed from QT_CONFIG in qconfig.pri 646# List options that need to be removed from QT_CONFIG in qconfig.pri
353QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 647: ${QCONFIG_REMOVE:=}
354 648
355# @ECLASS-VARIABLE: QCONFIG_DEFINE 649# @ECLASS-VARIABLE: QCONFIG_DEFINE
356# @DESCRIPTION: 650# @DESCRIPTION:
357# List variables that should be defined at the top of QtCore/qconfig.h 651# List variables that should be defined at the top of QtCore/qconfig.h
358QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 652: ${QCONFIG_DEFINE:=}
359 653
360# @FUNCTION: install_qconfigs 654# @FUNCTION: install_qconfigs
655# @INTERNAL
656# @DESCRIPTION:
361# @DESCRIPTION: Install gentoo-specific mkspecs configurations 657# Install gentoo-specific mkspecs configurations.
362install_qconfigs() { 658install_qconfigs() {
363 local x 659 local x
364 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 660 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
365 for x in QCONFIG_ADD QCONFIG_REMOVE; do 661 for x in QCONFIG_ADD QCONFIG_REMOVE; do
366 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 662 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
367 done 663 done
368 insinto ${QTDATADIR}/mkspecs/gentoo 664 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
369 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 665 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
370 fi 666 fi
371 667
372 if [[ -n ${QCONFIG_DEFINE} ]]; then 668 if [[ -n ${QCONFIG_DEFINE} ]]; then
373 for x in ${QCONFIG_DEFINE}; do 669 for x in ${QCONFIG_DEFINE}; do
374 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 670 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
375 done 671 done
376 insinto ${QTHEADERDIR}/Gentoo 672 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
377 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 673 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
378 fi 674 fi
379} 675}
380 676
381# @FUNCTION: generate_qconfigs 677# @FUNCTION: generate_qconfigs
382# @DESCRIPTION: Generates gentoo-specific configurations 678# @INTERNAL
679# @DESCRIPTION:
680# Generates gentoo-specific qconfig.{h,pri}.
383generate_qconfigs() { 681generate_qconfigs() {
384 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 682 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
385 local x qconfig_add qconfig_remove qconfig_new 683 local x qconfig_add qconfig_remove qconfig_new
386 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 684 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
387 [[ -f ${x} ]] || continue 685 [[ -f ${x} ]] || continue
388 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 686 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
389 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 687 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
390 done 688 done
391 689
392 # these error checks do not use die because dying in pkg_post{inst,rm} 690 # these error checks do not use die because dying in pkg_post{inst,rm}
393 # just makes things worse. 691 # just makes things worse.
394 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 692 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
401 699
402 # generate list of QT_CONFIG entries from the existing list 700 # generate list of QT_CONFIG entries from the existing list
403 # including qconfig_add and excluding qconfig_remove 701 # including qconfig_add and excluding qconfig_remove
404 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 702 for x in $(sed -n 's/^QT_CONFIG +=//p' \
405 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 703 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
406 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 704 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
407 done 705 done
408 706
409 # replace the existing QT_CONFIG list with qconfig_new 707 # replace the existing QT_CONFIG list with qconfig_new
410 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 708 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
411 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 709 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
435 fi 733 fi
436 fi 734 fi
437} 735}
438 736
439# @FUNCTION: qt4-build_pkg_postrm 737# @FUNCTION: qt4-build_pkg_postrm
738# @DESCRIPTION:
440# @DESCRIPTION: Generate configurations when the package is completely removed 739# Regenerate configuration when the package is completely removed.
441qt4-build_pkg_postrm() { 740qt4-build_pkg_postrm() {
442 generate_qconfigs 741 generate_qconfigs
443} 742}
444 743
445# @FUNCTION: qt4-build_pkg_postinst 744# @FUNCTION: qt4-build_pkg_postinst
745# @DESCRIPTION:
446# @DESCRIPTION: Generate configuration, plus throws a message about possible 746# Regenerate configuration, plus throw a message about possible
447# breakages and proposed solutions. 747# breakages and proposed solutions.
448qt4-build_pkg_postinst() { 748qt4-build_pkg_postinst() {
449 generate_qconfigs 749 generate_qconfigs
450 echo
451 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
452 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
453 ewarn "should recompile the packages providing these plugins. Also, make sure you"
454 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
455 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
456 ewarn
457 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
458 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
459 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
460 ewarn "configuration."
461 ewarn
462 ewarn "For more information, see http://doc.trolltech.com/${PV%.*}/plugins-howto.html"
463 echo
464} 750}
465 751
466# @FUNCTION: skip_qmake_build_patch 752# @FUNCTION: skip_qmake_build
753# @INTERNAL
467# @DESCRIPTION: 754# @DESCRIPTION:
468# Don't need to build qmake, as it's already installed from qt-core 755# Patches configure to skip qmake compilation, as it's already installed by qt-core.
469skip_qmake_build_patch() { 756skip_qmake_build() {
470 # Don't need to build qmake, as it's already installed from qt-core
471 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 757 sed -i -e "s:if true:if false:g" "${S}"/configure || die
472} 758}
473 759
474# @FUNCTION: skip_project_generation_patch 760# @FUNCTION: skip_project_generation
761# @INTERNAL
475# @DESCRIPTION: 762# @DESCRIPTION:
476# Exit the script early by throwing in an exit before all of the .pro files are scanned 763# Exit the script early by throwing in an exit before all of the .pro files are scanned.
477skip_project_generation_patch() { 764skip_project_generation() {
478 # Exit the script early by throwing in an exit before all of the .pro files are scanned
479 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 765 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
480 -i "${S}"/configure || die "Sed failed"
481} 766}
482 767
483# @FUNCTION: symlink_binaries_to_buildtree 768# @FUNCTION: symlink_binaries_to_buildtree
769# @INTERNAL
484# @DESCRIPTION: 770# @DESCRIPTION:
485# Symlink generated binaries to buildtree so they can be used during compilation 771# Symlinks generated binaries to buildtree, so they can be used during compilation time.
486# time
487symlink_binaries_to_buildtree() { 772symlink_binaries_to_buildtree() {
488 for bin in qmake moc uic rcc; do 773 for bin in qmake moc uic rcc; do
489 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 774 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
490 done 775 done
491} 776}
492 777
493# @FUNCTION: fix_library_files 778# @FUNCTION: fix_library_files
779# @INTERNAL
494# @DESCRIPTION: 780# @DESCRIPTION:
495# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 781# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
496# moves the *.pc-files into the pkgconfig directory 782# moves the *.pc files into the pkgconfig directory.
497fix_library_files() { 783fix_library_files() {
784 local libfile
498 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 785 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
499 if [[ -e ${libfile} ]]; then 786 if [[ -e ${libfile} ]]; then
500 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 787 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
501 fi 788 fi
502 done 789 done
503 790
504 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 791 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
505 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 792 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
506 if [[ -e ${libfile} ]]; then 793 if [[ -e ${libfile} ]]; then
507 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 794 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
508 795
509 # Move .pc files into the pkgconfig directory 796 # Move .pc files into the pkgconfig directory
510 dodir ${QTPCDIR} 797 dodir ${QTPCDIR#${EPREFIX}}
511 mv ${libfile} "${D}"/${QTPCDIR}/ \ 798 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
512 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
513 fi 799 fi
514 done 800 done
515 801
516 # Don't install an empty directory 802 # Don't install an empty directory
517 rmdir "${D}"/${QTLIBDIR}/pkgconfig 803 rmdir "${D}"/${QTLIBDIR}/pkgconfig
518} 804}
519 805
520# @FUNCTION: qt_use 806# @FUNCTION: qt_use
521# @USAGE: < flag > [ feature ] [ enableval ] 807# @USAGE: < flag > [ feature ] [ enableval ]
522# @DESCRIPTION: 808# @DESCRIPTION:
523# This will echo "${enableval}-${feature}" if <flag> is enabled, or 809# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
524# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 810# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
525# will be used for that. If [enableval] is not specified, it omits the 811# will be used for that. If [enableval] is not specified, it omits the
526# assignment-part 812# "-${enableval}" part.
527qt_use() { 813qt_use() {
528 local flag="${1}" 814 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
529 local feature="${1}"
530 local enableval=
531
532 [[ -n ${2} ]] && feature=${2}
533 [[ -n ${3} ]] && enableval="-${3}"
534
535 if use ${flag}; then
536 echo "${enableval}-${feature}"
537 else
538 echo "-no-${feature}"
539 fi
540}
541
542# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK
543# @DESCRIPTION:
544# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use
545# (eutils.eclass), line per line.
546#
547# Example:
548# @CODE
549# pkg_setup() {
550# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
551# ~x11-libs/qt-gui-${PV} qt3support"
552# qt4-build_check_use
553# }
554# @CODE
555
556# Run built_with_use on each flag and print appropriate error messages if any
557# flags are missing
558
559_qt_built_with_use() {
560 local missing opt pkg flag flags
561
562 if [[ ${1} = "--missing" ]]; then
563 missing="${1} ${2}" && shift 2
564 fi
565 if [[ ${1:0:1} = "-" ]]; then
566 opt=${1} && shift
567 fi
568
569 pkg=${1} && shift
570
571 for flag in "${@}"; do
572 flags="${flags} ${flag}"
573 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
574 flags="${flags}*"
575 else
576 [[ ${opt} = "-o" ]] && return 0
577 fi
578 done
579 if [[ "${flags# }" = "${@}" ]]; then
580 return 0
581 fi
582 if [[ ${opt} = "-o" ]]; then
583 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
584 else
585 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
586 fi
587 return 1
588}
589
590# @FUNCTION: qt4-build_check_use
591# @DESCRIPTION:
592# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
593# USE flags listed.
594#
595# If any of the required USE flags are missing, an eerror will be printed for
596# each package with missing USE flags.
597qt4-build_check_use() {
598 local line missing
599 while read line; do
600 [[ -z ${line} ]] && continue
601 if ! _qt_built_with_use ${line}; then
602 missing=true
603 fi
604 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
605 if [[ -n ${missing} ]]; then
606 echo
607 eerror "Flags marked with an * are missing."
608 die "Missing USE flags found"
609 fi
610} 815}
611 816
612# @FUNCTION: qt_mkspecs_dir 817# @FUNCTION: qt_mkspecs_dir
613# @RETURN: the specs-directory w/o path 818# @RETURN: the specs-directory w/o path
614# @DESCRIPTION: 819# @DESCRIPTION:
615# Allows us to define which mkspecs dir we want to use. 820# Allows us to define which mkspecs dir we want to use.
616qt_mkspecs_dir() { 821qt_mkspecs_dir() {
617 # Allows us to define which mkspecs dir we want to use.
618 local spec 822 local spec=
619 823
620 case ${CHOST} in 824 case "${CHOST}" in
621 *-freebsd*|*-dragonfly*) 825 *-freebsd*|*-dragonfly*)
622 spec="freebsd" ;; 826 spec=freebsd ;;
623 *-openbsd*) 827 *-openbsd*)
624 spec="openbsd" ;; 828 spec=openbsd ;;
625 *-netbsd*) 829 *-netbsd*)
626 spec="netbsd" ;; 830 spec=netbsd ;;
627 *-darwin*) 831 *-darwin*)
832 if use aqua; then
833 # mac with carbon/cocoa
834 spec=macx
835 else
836 # darwin/mac with x11
628 spec="darwin" ;; 837 spec=darwin
838 fi
839 ;;
840 *-solaris*)
841 spec=solaris ;;
629 *-linux-*|*-linux) 842 *-linux-*|*-linux)
630 spec="linux" ;; 843 spec=linux ;;
631 *) 844 *)
632 die "Unknown CHOST, no platform choosen." 845 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
633 esac 846 esac
634 847
635 CXX=$(tc-getCXX) 848 case "$(tc-getCXX)" in
636 if [[ ${CXX/g++/} != ${CXX} ]]; then 849 *g++*)
637 spec="${spec}-g++" 850 spec+=-g++ ;;
638 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 851 *icpc*)
639 spec="${spec}-icc" 852 spec+=-icc ;;
640 else 853 *)
641 die "Unknown compiler ${CXX}." 854 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
642 fi 855 esac
643 if [[ -n "${LIBDIR/lib}" ]]; then 856
644 spec="${spec}-${LIBDIR/lib}" 857 # Add -64 for 64bit profiles
858 if use x64-freebsd ||
859 use amd64-linux ||
860 use x64-macos ||
861 use x64-solaris ||
862 use sparc64-solaris
863 then
864 spec+=-64
645 fi 865 fi
646 866
647 echo "${spec}" 867 echo "${spec}"
648} 868}
649 869
650case ${EAPI:-0} in 870# @FUNCTION: qt_assistant_cleanup
651 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 871# @INTERNAL
872# @DESCRIPTION:
873# Tries to clean up tools.pro for qt-assistant ebuilds.
874# Meant to be called in src_prepare().
875# Since Qt 4.7.4 this function is a no-op.
876qt_assistant_cleanup() {
877 # apply patching to qt-assistant ebuilds only
878 [[ ${PN} != qt-assistant ]] && return
879
880 # no longer needed for 4.7.4 and later
881 version_is_at_least 4.7.4 && return
882
883 # different versions (and branches...) may need different handling,
884 # add a case if you need special handling
885 case "${MY_PV_EXTRA}" in
886 *kde-qt*)
887 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
888 -e "/mac/,/^embedded.*makeqpf$/d" \
889 -i tools/tools.pro || die "patching tools.pro failed"
890 ;;
891 *)
892 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
893 -e "/mac/,/^embedded.*makeqpf$/d" \
894 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
895 -i tools/tools.pro || die "patching tools.pro failed"
896 ;;
897 esac
898}
899
900# @FUNCTION: qt_nolibx11
901# @INTERNAL
902# @DESCRIPTION:
903# Ignore X11 tests for packages that don't need X libraries installed.
904qt_nolibx11() {
905 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
906 die "x11 check sed failed"
907}
908
652 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 909EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
653esac

Legend:
Removed from v.1.45  
changed lines
  Added in v.1.129

  ViewVC Help
Powered by ViewVC 1.1.20